<%
    Dim tmlFile

    If Request("template").Count > 0 Then
        tmlFile = Request("template")
    Else
        tmlFile = "template1.htm"
    End If

    Dim parser
    
    Set parser = Server.CreateObject("newObjects.utilctls.TextEmbedParser")
    
    ' AddTag parameters
    ' 1 - TAG name
    ' 2 - Has closing tag i.e. <BODY> ... </BODY>
    ' 3 - Allow self nesting. E.g. the tag may contain fellow tags in its content
    ' 4 - Copy information (more memory is used but convenient when retrieving information
    '       not very useful in case of template oriented usage)
    ' 5 - Disable other tags. If true no other tag could be contained in it.
    '       For example title may not contain any of the other tags
    ' 6 - Required attribute. If not empty the tag will be recognized only if it has
    '       an attribute with this name
    ' 7 - If the previous is not empty and this is set to non-empty value
    '       the tag will be recognized only if it conatians attribute (as defned by the prev. param.)
    '       and also if the attribute value equals to this parameter.
    ' The last two are useful for retrival of widelly used tags with certain characteristics only
    parser.AddTag "title",true,false,false,true,"",""
    parser.AddTag "BODY",true,false,false,false,"",""
    parser.AddTag "CUSTOM",true,true,false,false,"",""
    parser.AddTag "CUSTOMFIELD",false,false,false,true,"",""
    
    ' Load the template
    Dim sf ' Storages and files - FSO equivalent
    Set sf = Server.CreateObject("newObjects.utilctls.SFMain")
    Dim file
    Set file = sf.OpenFile(Server.MapPath(tmlFile))
    
    ' Parse it
    Dim template
    ' This reads the entire file as string and passes it to the parser
    Set template = parser.ParseString(file.ReadText)
    
    ' template contains the template's object model tree.
    ' Follows the real work
    
    Dim i,j,k,r ' Misc. numeric variables
    Dim section, section2, section3, section4, section5, section6, node, node2 
        ' Will be used when isnpecting the tree for different pusposes
    
    ' 1. Deal with the title
        ' This finds the node representing the <TITLE> tag
        Set node = template.FindByValue("__class","TITLE")(1)
        ' Get inner content
        Set node2 = node.FindByValue("__class","text/plain")(1)
        ' Why finding it and not just get the first element?
        ' If the user changes the template he/she could include some unexpected 
        ' tags in the title - not good - but with code above we are prepared for this (say it is maddness ;) )
        node2("__text") = "Template sample"
        
        ' Now replace this custom tag in the body with the same text
        
        Set node = template.FindByName("TITLE")(1)
        node("__class") = "text/plain" ' Converting it to plain text
        node("__text") = "Template sample"

        
    ' 2. Deal with the first segment
        Set section = template.FindByName("SECTION1")(1)
        ' Now we need a copy of it. 
        Set section2 = section.Clone
        ' Now we can remove the section contents
        section.Clear
        
        ' Now get the number of lines
        Randomize
        j = Int(Rnd(3) * 4 + 1)
        
        ' And we will create copies from the copy above, fill them with different data
        ' and add them to the cleared section
        For i = 1 To j
            Set section3 = section2.Clone
            ' Find the tag for the random number
            Set node = section3.FindByName("NUMBER")(1)
            node("__class") = "text/plain"
            node("__text") = Rnd(3)
            
            ' Find the tag for the line number
            Set node = section3.FindByName("LINE")(1)
            node("__class") = "text/plain"
            node("__text") = i
            
            ' Add this to the section
            section.Add "",section3
        Next

       
    ' 3. Now the more complicated section  - section2 (dual cycle)
        Set section = template.FindByName("SECTION2")(1)
        ' Copy
        Set section2 = section.Clone
        ' clear
        section.Clear
        
        ' Get the first random 
        Randomize
        k = Int(Rnd(3) * 4 + 1)
        For i = 1 to k
            ' Get a copy
            Set section3 = section2.Clone
        
            ' Get the second random
            r = Int(Rnd(3) * 4 + 1)
            
            ' Replace the LINES count tag
            Set node = section3.FindByName("LINES2")(1)
            node("__class") = "text/plain"
            node("__text") = r
            
            ' And prepare for the internal cycle
            Set section4 = section3.FindByName("SECTION2INNER")(1)
            Set section5 = section4.Clone
            ' Clear the original
            section4.Clear
            
            For j = 1 to r
                ' Get copy
                Set section6 = section5.Clone
                ' Replace the NUMBER tag
                Set node = section6.FindByName("NUMBER")(1)
                node("__class") = "text/plain"
                node("__text") = Rnd(3) * 4
                
                ' Add this to the containing section
                section4.Add "",section6
            Next            
            ' Add the entire stuff to the outer container
            section.Add "",section3
        Next
    
    ' FINALLY generate the document
    Response.Write parser.GenerateDoc(template)
  
%>