Dim indexFileName ,contentsFileName, projectFileName
indexFileName = "Index.hhk"
contentsFileName = "Table of Contents.hhc"
projectFileName = "HHProject.hhp"

' Determine if custom names are specified
If Not GlobalVariables("IndexFileName") = "" Then
    indexFileName = GlobalVariables("IndexFileName")
End If
If Not GlobalVariables("ContentsFileName") = "" Then
    contentsFileName = GlobalVariables("ContentsFileName")
End If
If Not GlobalVariables("ProjectFileName") = "" Then
    projectFileName = GlobalVariables("ProjectFileName")
End If


Dim sf
Set sf = CreateObject("newObjects.utilctls.SFMain")

' Helper procedures
Sub WriteParam(file,paramName,paramVal)
    file.WriteText "		<param name="""
    file.WriteText paramName & """ value=""" & paramVal & """>",1
End Sub

Sub GenerateIndex
    Dim file
    compiler.ReportMessage 100,"Index file: " & Info("SiteRootPathOutput") & "\" & indexFileName
    Set file = sf.CreateFile(Info("SiteRootPathOutput") & "\" & indexFileName)

    ' Write header
    file.WriteText "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML//EN"">",1
    file.WriteText "<HTML>",1
    file.WriteText "<HEAD>",1
    file.WriteText "</HEAD><BODY>",1
    file.WriteText "<UL>",1

    Dim kwds
    Set kwds = GlobalVariables("Collected.Keywords")
    Dim i,j,o
    
    For i = 1 To kwds.Count
        ' Create <LI> for each keyword
        file.WriteText "	<LI> <OBJECT type=""text/sitemap"">",1
            WriteParam file, "Name", kwds.Key(i)
            Set o = kwds(i)
            For j = 1 To o.Count
                WriteParam file, "Name", o.Key(j)
                WriteParam file, "Local", o(j)
            Next
        file.WriteText "    </OBJECT>",1
    Next
    
    ' Write footer
    file.WriteText "</UL>",1
    file.WriteText "</BODY></HTML>",1
    Set file = Nothing
End Sub

Sub TraceNode(file,node)
    Dim i
    For i = 1 To node.Count
        If IsObject(node(i)) Then
            file.WriteText "    <LI> <OBJECT type=""text/sitemap"">",1
            WriteParam file, "Name", node.Key(i)
            If Not node(i).Root = "" Then
                WriteParam file, "Local", node(i).Root
            End If
            file.WriteText "    </OBJECT>",1        
            ' Recurse    
            file.WriteText "    <UL>",1
            TraceNode file, node(i)
            file.WriteText "    </UL>",1
        Else
            ' Place link
            file.WriteText "    <LI> <OBJECT type=""text/sitemap"">",1
            WriteParam file, "Name", node.Key(i)
            WriteParam file, "Local", node(i)
            file.WriteText "    </OBJECT>",1        
        End If
    Next
End Sub

Sub GenerateContents
    Dim file
    compiler.ReportMessage 100,"Contents file: " & Info("SiteRootPathOutput") & "\" & contentsFileName
    Set file = sf.CreateFile(Info("SiteRootPathOutput") & "\" & contentsFileName)

    ' Write header
    file.WriteText "<!DOCTYPE HTML PUBLIC ""-//IETF//DTD HTML//EN"">",1
    file.WriteText "<HTML>",1
    file.WriteText "<HEAD>",1
    file.WriteText "</HEAD><BODY>",1
    file.WriteText "<OBJECT type=""text/site properties"">",1
	file.WriteText "<param name=""ImageType"" value=""Folder"">",1
    file.WriteText "</OBJECT>",1
    file.WriteText "<UL>",1

    Dim root
    Set root = GlobalVariables("Collected.SiteMap")
    
    TraceNode file, root
    
    ' Write footer
    file.WriteText "</UL>",1
    file.WriteText "</BODY></HTML>",1
    Set file = Nothing
End Sub

Sub GenerateProject
    Dim ini
    Set ini = sf.CreateFile(Info("SiteRootPathOutput") & "\" & projectFileName)
    
    ini.WriteText "[OPTIONS]",1
    ini.WriteText "Contents file=" & contentsFileName,1
    ini.WriteText "Index file=" & indexFileName,1
    ini.WriteText "",1
    
    ini.WriteText "[FILES]",1
    Dim i
    For i = 1 To Files.Count
        ini.WriteText Files(i)("Info")("FileRelative"),1
    Next
End Sub

GenerateIndex
GenerateContents
GenerateProject