' Namespaces
' ~~~~~~~~~~
' Project                 - Project tree
' Compiler                - Compiler object
' ProcessedFile           - File sction from the project
' Info                    - A collection of information about the file
' Configuration           - Configuration section or empty collection if no config is supplied
' GlobalVariables         - Configuration section or empty collection if no config is supplied

Dim numFile
numFile = 0

' Initialization Begin
' ~~~~~~~~~~~~~~~~~~~~


' Initialization End
' ~~~~~~~~~~~~~~~~~~

' Events
' ~~~~~~

Sub OnModifyParser(Parser)
    Parser.AddTag "meta",False,False,False,True,"name",""
    Parser.AddTag "title",True,False,True,True,"",""
End Sub

Function OnCheckStructure(Tree,Scripts,Customs)
    If IsObject(Customs("CopyRight")) Then
        Customs("CopyRight")("Class") = "Text"
        Customs("CopyRight")("Content") = GlobalVariables("CopyRightText")
    End If
    
   
    Dim found,coll,i,j,kwds,words,title
    
    ' Extract document title
    Set found = Tree.FindByValue("__class","title",1,1)
    If found.Count > 0 Then
        title = found(1)("__content")
    Else
        title = "Unnamed page"
    End If
    
    If IsObject(Customs("PageTitle")) Then
        Customs("PageTitle")("Class") = "Text"
        Customs("PageTitle")("Content") = title
    End If
    
    Set found = Tree.FindByValue("__class","META",1,100)
    
    ' Collect keywords
    
    Set coll = found.FindByValue("name","Keywords",1,100)
    Set kwds = GetCreateKeywordColl
    If coll.Count > 0 Then
        For i = 1 To coll.Count
            words = Split(coll(i)("CONTENT"),",")
            For j = 0 To UBound(words)
                AddKeyword kwds,Trim(words(j)),title
            Next
        Next
    End If
    
    Dim locs
    
    ' Collect the help structure
    Set coll = found.FindByValue("name","SiteMap",1,100)
    Set locs = GetCreateLocationColl
    If coll.Count > 0 Then
        For i = 1 To coll.Count
            AddLink locs,coll(i)("CONTENT"),title
        Next
    Else
        Compiler.ReportWarning -1,"No StieMap information. The file will not appear in the contents",0
    End If
    
    OnCheckStructure = True
End Function

Function OnRequireCompletion()
    OnRequireCompletion = "complete.vbs"
End Function


' Private functions
Function    GetCreateKeywordColl()
    If Not IsObject(GlobalVariables("Collected.Keywords")) Then
        ' Create it
        Dim kwd
        Set kwd = GlobalVariables.CreateNew
        GlobalVariables.Add "Collected.Keywords",kwd
        kwd.allowDuplicateNames = False
        kwd.allowUnnamedValues = False
    End If
    Set GetCreateKeywordColl = GlobalVariables("Collected.Keywords")
End Function

Function    GetCreateLocationColl()
    If Not IsObject(GlobalVariables("Collected.SiteMap")) Then
        ' Create it
        Dim siteMap
        Set siteMap = GlobalVariables.CreateNew
        GlobalVariables.Add "Collected.SiteMap",siteMap
        siteMap.allowDuplicateNames = True
        siteMap.allowUnnamedValues = True
        siteMap.Missing = Empty
    End If
    Set GetCreateLocationColl = GlobalVariables("Collected.SiteMap")
End Function

Sub AddKeyword(kwdColl,theWord,title)
    Dim kwdList,str
    
    If IsObject(kwdColl(theWord)) Then
        Set kwdList = kwdColl(theWord)
    Else
        Set kwdList = kwdColl.CreateNew
        kwdList.allowUnnamedValues = True
        kwdList.allowDuplicateNames = True
        kwdColl.Add theWord, kwdList
    End If
    str = Info("FileRelative")
    'str = Replace(str,"\","/")
    kwdList.Add title, str
End Sub

Sub AddLink(root,path,title)
    Dim arr, currentNode, i, o
    arr = Split(path,"/")
    
    Set currentNode = root
    For i = 0 to UBound(arr)
        If arr(i) = "." Then
            currentNode.Root = Info("FileRelative")
            Exit Sub
        ElseIf Not arr(i) = "" Then
            ' Find create sub node
            If Not IsObject(currentNode(arr(i))) Then
                Set o = currentNode.CreateNew
                currentNode.Add arr(i), o
            End If
            Set currentNode = currentNode(arr(i))
        'Else
            ' use current node
        End If
    Next
    ' Now put the link in the current node
    currentNode.Add title, Info("FileRelative")
End Sub