' Namespaces
' ~~~~~~~~~~
' Project                 - Project tree
' Compiler                - Compiler object
' ProcessedFile           - File sction from the project
' Info                    - A collection of information about the file
' Configuration           - Configuration section or empty collection if no config is supplied

Dim numFile
numFile = 0

' 

' Events
' ~~~~~~
Function OnProcessFile(fileVirtName)
    numFile = numFile + 1
    If numFile = 1 Then
        OnProcessFile = fileVirtName
    Else
        OnProcessFile = ""
    End If
End Function

Function OnCheckStructure(Tree,Scripts,Customs)
    On Error Resume Next
    OnCheckStructure = False
    
    Dim beginDetail,endDetail
    Set beginDetail = Nothing
    Set endDetail = Nothing
    Dim sqlQuery, DB
    sqlQuery = Configuration("SQL")
    'If Err.Number <> 0 Then Compiler.ReportError 0,Err.Description,0
    DB = Configuration("DB")
    DB = Replace(DB,"/","\")
    DB = Project("ASPToPlain")("SiteRoot") & DB
    
    Dim dbConn
    Set dbConn = CreateObject("ADODB.Connection")
    
    
    dbConn.Open "Driver={Microsoft Access Driver (*.mdb)};DBQ=" & DB & ";"
    If Err.Number <> 0 Then
        Compiler.ReportError 20001,"Cannot open the DB file: " & DB,0
        Exit Function
    End If
    
    ' Query the DB
    Dim rst
    Set rst = dbConn.Execute(sqlQuery)
    If Err.Number <> 0 Then
        Compiler.ReportError 20001,"Query failed: " & sqlQuery,0
        Exit Function
    End If
    
    ' Collect the info from the page
    Dim pageFields
    Set pageFields = CreateObject("newobjects.utilctls.VarDictionary")
    pageFields.Missing = ""
    
    Dim f
    For Each f In Tree
        If f("Class") = "Script" Then
            Select Case Trim(f("Content"))
                Case "BeginDetail"
                    Set beginDetail = f
                    Compiler.ReportMessage 0,"BeginDetail found"
                Case "EndDetail"
                    Set endDetail   = f
                    Compiler.ReportMessage 0,"EndDetail found"
                Case Else
                    If (Not beginDetail Is Nothing) And (endDetail Is Nothing) Then
                        pageFields.Add Trim(f("Content")),"Field"
                        Compiler.ReportMessage 0,"Field found: " & f("Content")
                        f("Class") = "Assignment"
                        f("Content") = "dbqRst(""" & Trim(f("Content")) & """).Value"
                    End If
            End Select
        End If
    Next
    
    If (beginDetail Is Nothing) Or (endDetail Is Nothing) Or pageFields.Count = 0 Then
        Compiler.ReportError 20002,"Syntax error in the page",0
        Exit Function
    End If
    
    ' Generate code
    Dim code1,code2
    ' Open code
    code1 = "Dim dbqConn,dbqRst" & vbCrLf & _
            "Set dbqConn = Server.CreateObject(""ADODB.Connection"")" & vbCrLf & _
            "dbqConn.Open ""Driver={Microsoft Access Driver (*.mdb)};DBQ="" & Server.MapPath(""" & Configuration("DB") & """) & "";""" & vbCrLf & _
            "Set dbQRst = dbqConn.Execute(""" & sqlQuery & """)" & vbCrLf & _
            "Dim dbqRecBegin,dbqCurPage, dbqCurRec" & vbCrLf & _
            "If Request(""Page"").Count = 0 Then dbqCurPage = 0 Else dbqCurPage = Request(""Page"")(1)" & vbCrLf & _
            "dbqRecBegin = dbqCurPage * " & Configuration("PageSize") & vbCrLf & _
            "dbqCurRec = 0" & vbCrLf & _
            "While Not dbqRst.EOF" & vbCrLf & _
            "   dbqCurRec = dbqCurRec + 1" & vbCrLf & _
            "   If dbqCurRec > dbqRecBegin And dbqCurRec <= (dbqRecBegin + " & Configuration("PageSize") & ") Then"
    ' Close code
    code2 = "   End If" & vbCrLf & _
            "   dbqRst.MoveNext" & vbCrLf & _
            "Wend"
    
    beginDetail("Content") = code1
    endDetail("Content") = code2
    
    ' Adjust fields code
    Dim I,temp
    For Each I In pageFields
        
        If Not rst.EOF Then
            temp = rst(I).Value
            If Err.Number <> 0 Then
                Compiler.ReportError 20003,"Cannot find the field (" & I & ") in the query result.",0
            End If
        End If
    Next
    
    OnCheckStructure = True
End Function

